---
title: AudioScheduledSourceNode.start()
slug: Web/API/AudioScheduledSourceNode/start
tags:
  - API
  - Audio
  - AudioScheduledSourceNode
  - Media
  - Method
  - NeedsExample
  - Node
  - Reference
  - Web Audio API
  - play
  - sound
  - start
---
<p>{{APIRef("Web Audio API")}}</p>

<p><span class="seoSummary">The <code>start()</code> method on {{domxref("AudioScheduledSourceNode")}} schedules a sound to begin playback at the specified time. If no time is specified, then the sound begins playing immediately.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>AudioScheduledSourceNode</em>.start([<em>when</em> [, offset [, duration]]]);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>when</code> {{optional_inline}}</dt>
 <dd>The time, in seconds, at which the sound should begin to play. This value is specified in the same time coordinate system as the {{domxref("AudioContext")}} is using for its {{domxref("AudioContext.currentTime", "currentTime")}} attribute. A value of 0 (or omitting the <code>when</code> parameter entirely) causes the sound to start playback immediately.</dd>
 <dt><code>offset</code> {{optional_inline}}</dt>
 <dd>A floating-point number indicating the offset, in seconds, into the audio buffer where playback should begin. If 0 is passed then the playback will start from the beginning.</dd>
 <dt><code>duration</code> {{optional_inline}}</dt>
 <dd>A floating-point number indicating the duration, in seconds, to be played. If no value is passed then the duration will be equal to the length of the audio buffer minus the offset value</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>InvalidStateNode</code></dt>
 <dd>The node has already been started. This error occurs even if the node is no longer running because of a prior call to {{domxref("AudioScheduledSourceNode.stop", "stop()")}}.</dd>
 <dt><code>RangeError</code></dt>
 <dd>The value specified for <code>when</code> is negative.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>This example demonstrates how to create an {{domxref("OscillatorNode")}} which is scheduled to start playing in 2 seconds and stop playing 1 second after that. The times are calculated by adding the desired number of seconds to the context's current time stamp returned by {{domxref("AudioContext.currentTime")}}.</p>

<pre class="brush: js">context = new AudioContext();
osc = context.createOscillator();
osc.connect(context.destination);

/* Schedule the start and stop times for the oscillator */

osc.start(context.currentTime + 2);
osc.stop(context.currentTime + 3);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-audioscheduledsourcenode-start', 'start()')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioScheduledSourceNode.start")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
 <li>{{domxref("AudioScheduledSourceNode.stop", "stop()")}}</li>
 <li>{{domxref("AudioScheduledSourceNode")}}</li>
 <li>{{domxref("AudioBufferSourceNode")}}</li>
 <li>{{domxref("ConstantSourceNode")}}</li>
 <li>{{domxref("OscillatorNode")}}</li>
</ul>
